<script setup lang="ts">
import { type Materail } from "@/types/Material";
import { computed, nextTick, onMounted, ref, type Ref } from "vue";
import { VContainer, type VForm } from "vuetify/components";

const initialStock: Materail = {
    id: 0,
    name: "",
    QTY: 0,
    unit: "",
    min: 0,
};



const headers = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'Name',
        key: 'name',
        value: 'name'
    },
    {
        title: 'QTY',
        key: 'QTY',
        value: 'QTY'
    },
    {
        title: 'Unit',
        key: 'unit',
        value: 'unit'
    }, {
        title: 'Min',
        key: 'min',
        value: 'min'
    },

    { title: 'Actions', key: 'actions', sortable: false }

]
const headers1 = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'Name',
        key: 'name',
        value: 'name'
    },
    {
        title: 'QTY',
        key: 'QTY',
        value: 'QTY'
    },
    {
        title: 'Unit',
        key: 'unit',
        value: 'unit'
    }, {
        title: 'Min',
        key: 'min',
        value: 'min'
    }]



function closeDialog() {
    dialog.value = false
    nextTick(() => {
        editedStock.value = Object.assign({}, initialStock)
        editedIndex = -1
    })
}

async function save() {
    const { valid } = await refForm.value!.validate()
    if (!valid) return
    if (editedIndex > -1) {
        Object.assign(material.value[editedIndex], editedStock.value)
    } else {
        editedStock.value.id = lastId++
        material.value.push(editedStock.value)
    }
    editedIndex = -1
    closeDialog()
}
function closeDelete() {
    dialogDelete.value = false
    nextTick(() => {
        editedStock.value = Object.assign({}, initialStock)
    })
}

function deleteItemConfirm() {
    material.value.splice(editedIndex, 1)
    closeDelete()
}

function deleteItem(item: Materail) {
    editedIndex = material.value.indexOf(item)
    editedStock.value = Object.assign({}, item)
    dialogDelete.value = true
}
function editItem(item: Materail) {
    editedIndex = material.value.indexOf(item)
    editedStock.value = Object.assign({}, item)
    dialog.value = true
}

const snackbar = ref(false);
const refForm = ref<VForm | null>(null)
let lastId = 7
let editedIndex = -1
const updateDialog = ref(false)
const material = ref<Materail[]>([])
const lowStockItems = ref<Materail[]>([])
const dialog = ref(false)
const dialog1 = ref(false)
const form = ref(false)
const loading = ref(false)
const dialogDelete = ref(false)
function onSubmit() { }
const editedStock = ref<Materail>(JSON.parse(JSON.stringify(initialStock)))

function initialize() {
    material.value = [{
        id: 1,
        name: 'น้ำตาล',
        QTY: 10,
        unit: 'kilogram',
        min: 3,
    }, {
        id: 2,
        name: 'น้ำเชื่อม',
        QTY: 10,
        unit: 'liter',
        min: 3,
    }, {
        id: 3,
        name: 'เมล็ดกาแฟ',
        QTY: 20,
        unit: 'kilogram',
        min: 5,
    }, {
        id: 4,
        name: 'ผงชาเขียว',
        QTY: 2,
        unit: 'kilogram',
        min: 5,
    }, {
        id: 5,
        name: 'นมข้นหวาน',
        QTY: 2,
        unit: 'liter',
        min: 5,
    }
        , {
        id: 6,
        name: 'ผงโกโก้',
        QTY: 1,
        unit: 'kilogram',
        min: 3,
    }
    ]

}

onMounted(() => {
    initialize()
})

function checkStock() {
    const lowStockItems = material.value.filter(item => item.QTY < item.min);

    console.log("Low Stock Items:", lowStockItems);

}
function addStock() {

}

const filteredMaterial = computed(() => {
    return material.value.filter(item => item.QTY < item.min);
});
function closeUpdate() {
    updateDialog.value = false
}
</script>

<template>
    <v-Container style="margin-bottom: 6cap;">
        <v-data-table :headers="headers" :items="material">
            <template v-slot:top>
                <v-toolbar flat style="background-color: rgb(97, 63, 45, 0.867);">
                    <v-toolbar-title style="color: whitesmoke;">Material</v-toolbar-title>
                    <v-divider class="mx-4" inset vertical></v-divider>
                    
                    
                    
                        <v-dialog v-model="dialog1" fullscreen :scrim="false" transition="dialog-bottom-transition">
                            <template v-slot:activator="{ props }">
                                <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4" color="black" dark v-bind="props" >
                                    Check Stock
                                </v-btn>
                            </template>
                            <v-card>
                                <v-toolbar dark color="brown">
                                    <v-btn icon dark @click="dialog1 = false">
                                        <v-icon>mdi-close</v-icon>
                                    </v-btn>
                                    <v-toolbar-title >CheckStock</v-toolbar-title>
                                    <v-spacer></v-spacer>
                                    <v-toolbar-items>
                                        <v-btn style="background-color: rgba(35, 26, 15, 0.678); width: 150px; height: 60px"  variant="text" @click="dialog1 = false">
                                            Save
                                        </v-btn>
                                    </v-toolbar-items>
                                </v-toolbar>
                                <v-data-table :headers="headers1" :items="filteredMaterial"></v-data-table>

                            </v-card>
                        </v-dialog>
                    

                    <!-- UPDATE STOCK -->
    <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4">
      Import
        <v-dialog v-model="updateDialog" activator="parent" width="400" persistent>
          <v-card>
            <v-card-title style="text-align: center;">
              <span class="font">Import</span>
            </v-card-title>
            <v-sheet class="overflow-auto">
              <v-table>
                <thead>
                  <tr>
                    <th class="text-center">Name</th>
                    <th class="text-left">Quantity</th>
                  </tr>
                </thead>
                <tbody>
                  <tr v-for="item in material" :key="item.name">
                    <td>{{ item.name }}</td>
                    <td>
                      <v-responsive max-width="100">
                        <v-text-field v-model="item.QTY"></v-text-field>
                      </v-responsive>
                    </td>
                  </tr>
                </tbody>
              </v-table>
            </v-sheet>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn
                style="background-color: rgba(216, 201, 201); width: 150px; height: 50px"
                variant="flat"
                @click="closeUpdate()"
              >
                Close
              </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-btn>

                    <v-dialog v-model="dialog" persistent width="1024">
                        <template v-slot:activator="{ props }">
                            <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4" color="black" v-bind="props">
                                Add Stock
                            </v-btn>
                        </template>
                        <v-card>
                            <v-card-title>
                                <span class="text-h5">Add Stock</span>
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                                    <v-container>
                                        <v-row>
                                            <v-col cols="6" sm="6" >
                                                <v-text-field v-model="editedStock.name" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                    label="Name"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedStock.QTY" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                    label="QTY"></v-text-field>
                                            </v-col>

                                            <v-col cols="6" sm="6">
                                                <v-combobox label="Unit" :items="['kilogram', 'liter']"
                                                    v-model="editedStock.unit"></v-combobox>
                                            </v-col>

                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedStock.min" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" clearable
                                                    label="Min"></v-text-field>
                                            </v-col>

                                        </v-row>

                                    </v-container>

                                </v-form>
                                <small  style="color: black;" >Please check the accuracy!!</small>
                            </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4" color="blue-darken-5" variant="text" @click="closeDialog">Close</v-btn>
                                <v-btn style="background-color: rgba(216, 201, 201); width: 150px; height: 45px" class="mr-4" color="blue-darken-5" variant="text" @click="save()">Save</v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>

                    <!-- Delete Dialog -->
                    <v-dialog v-model="dialogDelete" max-width="500px">
                        <v-card>
                            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                                <v-spacer></v-spacer>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </v-toolbar>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="editItem(item)" color="blue-darken-1">
                    mdi-pencil
                </v-icon>
                <v-icon size="small" @click="deleteItem(item)" color="red">
                    mdi-delete
                </v-icon>
            </template>
            <template v-slot:no-data>
                <v-btn color="primary" @click="initialize">
                    Reset
                </v-btn>
            </template>
        </v-data-table>
    </v-Container>
</template>